/*
Class providing a 3D camera with projection and view matrix.

*/
#pragma once

#include "math/Math.h"
#include "WindowProperties.h"
#include <vector>
#include <algorithm>


class Camera
{
public:
	Camera(WindowProperties* window_props);
	~Camera();

	void update();

	math::Matrix44f TransformationMatrix;
	math::Matrix44f &getViewMatrix();
	math::Matrix44f &getProjectionMatrix();


private:

	float ZNear;
	float ZFar;
	float FoV;
	
	WindowProperties* WindowProps;

	math::Matrix44f ProjectionMatrix;
	math::Matrix44f ViewMatrix;

};
