/*
Tool that clears entire strokes.


*/
#pragma once
#include "Tool.h"
#include "Kinect Test\Stroke.h"
#include "UndoRedoManager.h"


class StrokeEraser2D : public Tool
{
public:

	StrokeEraser2D(std::vector<Stroke>* strokes, int* selected_stroke_id);
	~StrokeEraser2D();

	void updateLeftHandInput(Pose &pose); 
	void updateRightHandInput(Pose &pose);
	void updateBothHandInput(Pose &pose); 

	void update(Pose &pose);
	void render();
	void undo();
	void redo();

	int getTextureID(){return TextureID;};

private:

	// pointer to strokes
	std::vector<Stroke>* Strokes;
	// we need to know the selected stroke index that shall be erased
	int* SelectedStrokeID;

	// undo/redo lists
	std::vector<Stroke> UndoList;
	std::vector<Stroke> RedoList;

	// tool icon texture
	int TextureID;
};